#Set p4config
export P4CONFIG=.p4config
echo P4CONFIG=.p4config >> /etc/bash.bashrc
#Install the package
sudo echo "deb http://package.perforce.com/apt/ubuntu xenial release" >> /etc/apt/sources.list
wget -qO - http://package.perforce.com/perforce.pubkey | sudo apt-key add -
sudo apt-get -y install aptitude
sudo aptitude update
#Install packages the HTH trigger needs
sudo aptitude -y install libnet-ssleay-perl libio-socket-ssl-perl helix-git-connector helix-cli helix-p4d
sudo /opt/perforce/sbin/configure-helix-p4d.sh -n perforce1 -p ssl:192.168.2.72:1666 -r /opt/perforce/servers/perforce1 -u super -P REinforce --unicode
#Create a workspace on the gconn machine
echo REinforce > hws/passwd
mkdir -p ws/depot
mkdir -p ws/.hth/triggers
cd ws
cp ../hws/p4_config ./.p4config
p4 trust -y
p4 login < ../hws/passwd
p4 depot -i < ../hws/hth_depot
p4 client -i < ../hws/client 
#Configure gconn
sudo /opt/perforce/git-connector/bin/configure-git-connector.sh -n --p4port ssl:192.168.2.72:1666 --super super --superpassword REinforce --graphdepot graph --gcuserp4password REinforce --https --gconnhost 192.168.2.72 --forcehttps --ssh --sshuser git --croninterval 1 --serverid gconn1
#Export the location of the gconn configuration file, necessary for enabling mirroring
sudo -u git -i
export GCONN_CONFIG=/opt/perforce/git-connector/gconn.conf
echo GCONN_CONFIG=/opt/perforce/git-connector/gconn.conf >> ~/.bashrc
#Add an SSH key for user 'jen'.
sudo -u vagrant -i
cd /home/vagrant/ws
p4 trust -y
p4 login < /home/vagrant/hws/passwd
#Create the public key for user jen.
#We do not want the private key in the workspace.
cd /home/vagrant/hws
rm jen_key*
ssh-keygen -t rsa -f jen_key
p4 -u super -p ssl:192.168.2.72:1666 user -f -i < helix_user
p4 -u super -p ssl:192.168.2.72:1666 pubkey -u jen -i < /home/vagrant/hws/jen_key.pub
#Give user jen admin permissions to the depot graph
p4 -u super -p ssl:192.168.2.72:1666 grant-permission -u jen -p admin -d graph
#set the password for jen
p4 -u super -p ssl:192.168.2.72:1666 configure set security=1
p4 -u super -p ssl:192.168.2.72:1666 passwd -P REinforce jen
#Ensure user 'jen' is logged in
p4 -p ssl:192.168.2.72:1666 -u jen login < /home/vagrant/hws/passwd
#Add some data to the graph depot
git config --global http.sslVerify false
git config --global user.email jen@example.com
p4 -u super -p ssl:192.168.2.72:1666 repo -i < orca_repo
cd /home/vagrant
mkdir testrepos
cd testrepos
git clone https://github.com/GNOME/orca.git
cd orca
git remote rename origin upstream
git remote add origin https://jen:REinforce@192.168.2.72/graph/orca
git push -u --all origin
#For now we leave security level as is, just for convenients.
#Copy the trigger required for pushes to graph depots to be reported in HTH to the Helix Server
cd /home/vagrant/ws/.hth/triggers
cp /home/vagrant/hws/hth-trigger.* .
p4 reconcile
p4 submit -d "Adding the trigger required for events to be reported in HTH activity stream"
p4 triggers -i < /home/vagrant/hws/triggers
#Create the user that HTH will use when running commands
p4 user -f -i < /home/vagrant/hws/hth_user
p4 -u super -p ssl:192.168.2.72:1666 passwd -P REinforce hth_user
